Show diff link when appropriate on talk page notifications
Closed, ResolvedPublic

Assigned To
None
Priority
Unbreak Now!
Author
Mattflaschen
Subscribers
Risker, Vibhabamba, MZMcBride and 6 others
Projects
Reference
bz48183
Description

There has been some discussion at bug 47954 about when/if Echo should show a diff link to a talk page change.

One suggestion was to link it from the timestamp. Another possibility is to show the diff link when a section link is not available (e.g. it wasn't a section edit).


Version: master
Severity: normal
See Also:
https://bugzilla.wikimedia.org/show_bug.cgi?id=47954
https://bugzilla.wikimedia.org/show_bug.cgi?id=46937

bzimport added a project: Echo.Via ConduitNov 22 2014, 1:16 AM
bzimport added a subscriber: wikibugs-l.
bzimport set Reference to bz48183.
Mattflaschen created this task.Via LegacyMay 6 2013, 9:56 PM
Fabrice_Florin added a comment.Via ConduitMay 7 2013, 6:45 PM

I think a subtle link on the timestamp might be a good idea, since many users are asking for this options, with good reasons (it's really hard to find your new message on the talk page without it).

I've Cc:d Vibha on this, with the recommendation that we keep the current look and feel of the gray timestamp, but have it link to the diff when appropriate.

The alternative proposal to link to the diff when a section link is not available might also work, but would be inconsistent.

Either way, we need to find a solution to this problem, because it is very frustrating to get notified that you have a new message, but be unable to find it when you click on the notification.

Mattflaschen added a comment.Via ConduitMay 7 2013, 8:13 PM

I don't think a diff *alone* is a good user experience for the simple case of "posted a new talk page section". It's better to have a link to send them directly to the right section of the page.

I would recommend implementing bug 47954 at least for new sections, and possibly for editing existing ones.

I think a diff link in the timestamp in all cases is reasonable.

MZMcBride added a comment.Via ConduitMay 7 2013, 10:38 PM

(In reply to comment #2)

I don't think a diff *alone* is a good user experience for the simple case of
"posted a new talk page section". It's better to have a link to send them
directly to the right section of the page.

I think the whole rectangle should be a link to the talk page section (bug 47665).

Mattflaschen added a comment.Via ConduitMay 7 2013, 10:43 PM

(In reply to comment #3)

I think the whole rectangle should be a link to the talk page section (bug
47665).

There is not always a section link available, hence this bug. And so far I like the idea that the timestamp is the diff link.

MZMcBride added a comment.Via ConduitMay 7 2013, 10:46 PM

(In reply to comment #4)

There is not always a section link available, hence this bug. And so far I
like the idea that the timestamp is the diff link.

Err, then the rectangle would just be a link to the talk page, of course. The issue is that making a very small piece of text (e.g., the timestamp) the most important link makes the user experience really painful, particularly on touchscreen devices.

kaldari added a comment.Via ConduitMay 8 2013, 7:06 PM

This is a hard issue to solve since we don't have a real messaging system. Talk page 'posts' may involve multiple sections, no sections, removing content, blanking the whole page, etc. This is why many power users prefer to just look at the diff rather than the page. Unfortunately, our diff interface is rather complicated and if we sent new users there by default it would only cause confusion (especially since it's not obvious how to reply to things from the diff). So unfortunately, we have valid use cases for 2 different link destinations from the notification. Of the two, I would say the talk page link (or section link) is more important, however, so I'm sympathetic to MZ's argument.

Risker added a comment.Via ConduitMay 15 2013, 3:59 AM

(In reply to comment #6)

This is a hard issue to solve since we don't have a real messaging system.
Talk
page 'posts' may involve multiple sections, no sections, removing content,
blanking the whole page, etc. This is why many power users prefer to just
look
at the diff rather than the page. Unfortunately, our diff interface is rather
complicated and if we sent new users there by default it would only cause
confusion (especially since it's not obvious how to reply to things from the
diff). So unfortunately, we have valid use cases for 2 different link
destinations from the notification. Of the two, I would say the talk page
link
(or section link) is more important, however, so I'm sympathetic to MZ's
argument.

I disagree; it's not unusual for talk pages to have very extensive conversations going. The diff really makes a huge difference, to the point that I'm ignoring the system and going straight to page histories instead of using anything you're providing. It is even more important in the email messages, because users may have multiple wikis from which they are receiving notifications (as I discovered tonight). Links to just the user talk page are unhelpful, even for newbies.

Fabrice_Florin added a comment.Via ConduitMay 15 2013, 4:04 PM

Hi Risker,

Thanks for bringing up this important issue on the Notification talk page -- and for following up here. We discussed your concerns yesterday and propose this short-term solution, if it works for you.

We would like to add a '(show changes)' link for all talk page messages in the upcoming HTML email notifications, as well as in the archive page. So users will have the option to go straight to the diff page by clicking on this link if they want.

This is a tough challenge to solve, because we're serving both new users and experienced users like you with this feature. To a new user, the diff page is largely incomprehensible and useless as currently designed. To an experienced user like you, it is incredibly useful. At the same time, it's not a good idea to offer completely different functions for different user groups, so we need a solution that serves them both effectively.

For now, we would like to hold off on adding this 'show changes' link on the flyout, because putting more than one link per notification in that limited space tends to overwhelm users with too many decisions. However, we will test this specifically with users in coming weeks, and are prepared to revisit this temporary decision after we have more feedback.

Would this plan work for you?

Peteforsyth added a comment.Via ConduitMay 16 2013, 6:01 AM

Fabrice, I am having a hard time with the generalizing about what is easy or hard for a new user. New users sometimes learn directly from the software, sometimes by asking questions, sometimes by finding instructions online, sometimes by being taught in person. What is or is not easy for a new user is, in my eyes, an open question. In fact, what is HARD for a new user is when they ask an experienced user how something works, and the experienced user throws up their hands and says "last month I could have told you, but now everything changes week by week and I have no idea." That is the circumstance that is being created here.

The experienced users around the world, who are among the best resources for new users learning wikis, know how diffs work. A diff link certainly takes some learning, but learning is possible -- at least when a platform has some consistency.

kaldari added a comment.Via ConduitMay 22 2013, 12:14 AM

We also need to figure out how to present the diff link in the email. In the old emails it said:

... see
http://core.localhost.wikimedia.org/index.php/User_talk:Kaldari for the
current revision.

See
http://core.localhost.wikimedia.org/index.php?title=User_talk:Kaldari&diff=next&oldid=1963
to view this change.

Now it just says:

...
View more:

http://core.localhost.wikimedia.org/index.php/User_talk:Kaldari

Perhaps it should say:

View your talk page:
http://core.localhost.wikimedia.org/index.php/User_talk:Kaldari

View this change:
http://core.localhost.wikimedia.org/index.php?title=User_talk:Kaldari&diff=next&oldid=1963

Thoughts?

kaldari added a comment.Via ConduitMay 22 2013, 12:15 AM

Wow, the formatting on that got totally mangled :(

Mattflaschen added a comment.Via ConduitMay 22 2013, 12:16 AM

I think that's fine for the plain text version. You could consider not including the diff link if it's simply a new section.

gerritbot added a comment.Via ConduitMay 22 2013, 12:22 AM

Related URL: https://gerrit.wikimedia.org/r/64876 (Gerrit Change Iacd269a489c93b4fc4d28306915658fad372f50d)

Fabrice_Florin added a comment.Via ConduitMay 30 2013, 9:48 PM

For this feature, our design team recommends that we add secondary action links next to the timestamp on the flyout, as illustrated in this mockup:

http://en.wikipedia.org/wiki/File:Notifications_Flyout_Single_Targets_Closeup.png

So for talk message notifications, the primary link would go to the talk page, but a secondary link to the diff page will also be available, for people who prefer that solution.

We also propose to make the entire notification one large target, as suggested by several community members -- and to be consistent with best practices and user expectations on the web. When users hover over a notification, that target would either underline in the flyout, as shown in the mockup -- or use a comparable solution to let people know what to expect when they click on the notification.

This seems to be the most practical solution, after careful review of all our options. The good news is that this solution lets us provide these secondary links on all touchpoints, including flyout, archive and most email notifications.

Risker added a comment.Via ConduitJun 26 2013, 3:38 AM

(In reply to comment #14)

For this feature, our design team recommends that we add secondary action
links
next to the timestamp on the flyout, as illustrated in this mockup:

http://en.wikipedia.org/wiki/File:
Notifications_Flyout_Single_Targets_Closeup.png

So for talk message notifications, the primary link would go to the talk
page,
but a secondary link to the diff page will also be available, for people who
prefer that solution.

We also propose to make the entire notification one large target, as
suggested
by several community members -- and to be consistent with best practices and
user expectations on the web. When users hover over a notification, that
target
would either underline in the flyout, as shown in the mockup -- or use a
comparable solution to let people know what to expect when they click on the
notification.

This seems to be the most practical solution, after careful review of all our
options. The good news is that this solution lets us provide these secondary
links on all touchpoints, including flyout, archive and most email
notifications.

This seems to have stalled completely, as the proposed change in the mockup is not in effect. As well, and more importantly, there are still no diffs in the emails.

I'm having a hard time understanding what's so difficult about putting diffs into the emails: after the last month, where I've been getting multiple daily email notices about changes on pages I watch on Meta, every last one of them with a diff to the specific change, a diff to all changes since I last visited, a link to the page, and half a dozen other things (all in a nice plain text email) - I'm calling balderdash that it's not possible to do this with this software too. Reverse engineer it if you have to, but for heaven's sake please give us back the diffs. The emails I am now getting from English Wikipedia aren't worth the space they take up in my inbox.

Fabrice_Florin added a comment.Via ConduitJun 26 2013, 6:15 AM

Hi Risker,

We're nearly done with the new flyout links with diffs, and expect to deploy that feature next week.

We're also adding these links to the plain text emails -- as well as the upcoming HTML Emails, as demonstrated in this updated mockup: http://commons.wikimedia.org/wiki/File:Notifications-HTML-Email-Single-Example-Cropped.png

These tasks are our two highest priorities for Notifications right now. Sorry this has taken so long, due to limited resources on this project.

Thanks for your patience.

bzimport added a comment.Via ConduitJun 26 2013, 5:56 PM

bsitu wrote:

The diff link is added to the html and plain text email in the html email patch

Risker added a comment.Via ConduitJun 26 2013, 6:04 PM

(In reply to comment #16)

Hi Risker,

We're nearly done with the new flyout links with diffs, and expect to deploy
that feature next week.

We're also adding these links to the plain text emails -- as well as the
upcoming HTML Emails, as demonstrated in this updated mockup:
http://commons.wikimedia.org/wiki/File:Notifications-HTML-Email-Single-
Example-Cropped.png

These tasks are our two highest priorities for Notifications right now. Sorry
this has taken so long, due to limited resources on this project.

Thanks for your patience.

Thanks for the screenshot, Fabrice. I'm going to say this, although I'm pretty sure other people will tell you the same thing: what I see there looks identical in format to the kind of spam that I discard literally hundreds of times a month as a listadmin for multiple mailing lists, and that very consistently winds up in my own spam folders despite my setting a very high threshold for referral to spam. I think you should reconsider the use of html. "Pretty" is meaningless when it also means "goes in the spam folder and is never read". Even on my non-wiki related personal emails, without any spam setting, this would wind up in the spam folder. If anything, I suggest the default be plain text, making the html optional.

gerritbot added a comment.Via ConduitJun 27 2013, 5:53 PM

Change 64876 merged by jenkins-bot:
Adding diff link to talk page notifications for email

https://gerrit.wikimedia.org/r/64876

Fabrice_Florin added a comment.Via ConduitJul 3 2013, 12:43 AM

As promised, we have just released new links to diff pages for three notifications on the English Wikipedia, in response to your request. This feature is now live for talk page notifications, as well as for mentions and thanks notifications. These diff links now appear both on the notifications flyout, near the timestamp ('View changes') -- as well as in the plain text emails. I hope this address your concerns effectively. Please let us know if you have any questions or follow-up recommendations. Enjoy the new features!

Add Comment

Column Prototype
This is a very early prototype of a persistent column. It is not expected to work yet, and leaving it open will activate other new features which will break things. Press "\" (backslash) on your keyboard to close it now.